
#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <string.h>
#include <io.h>
#include <conio.h>
#include <dir.h>
#include <dirent.h>
#include "msg.h"

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

struct _CNMHDR cnmhdr;
struct _CNMMHDR cnmmhdr;
struct _CNMMHDR cbuf;
struct _CNMTDX cnmtdx;
struct _CFG cfg;

void getcfg(void);


void main()
{
   char fnme[65],xnme[65];
   FILE *tfd,*xfd;
   struct find_t fb;
   char *p;
   int done,crecord=0;

   getcfg();
   _setcursortype(_NOCURSOR);
   printf("\nCNReIdx v1.01 - (c)1993 Simon Ewins - "__DATE__" @ "__TIME__"\n");
   sprintf(fnme,"%s*.Msg",".\\MAIL\\");
   done=_dos_findfirst(fnme,_A_NORMAL,&fb);
   while(!done) {
      sprintf(fnme,"%s%s",".\\MAIL\\",fb.name);
      tfd=fopen(fnme,"r+b");
      strcpy(xnme,fnme);
      p=strrchr(xnme,'.')+1;
      strcpy(p,"To");
      xfd=fopen(xnme,"w+b");
      if(!xfd) {
         fclose(tfd);
         printf("Error: Can't create %s\n",xnme);
      } else {
         if(tfd) {
            crecord=0;
            printf("\nReIndexing %12s:",fb.name);
            fread(&cnmhdr,sizeof(cnmhdr),1,tfd);
            while(TRUE) {
               memset(&cnmtdx,0,sizeof(cnmtdx));
               cnmtdx.offset=ftell(tfd);
               fread(&cnmmhdr,sizeof(cnmmhdr),1,tfd);
               if(feof(tfd)) break;                   /* exit loop here */
               crecord++;
               printf("\rReIndexing %12s: %5d",fb.name,crecord);
               strcpy(cnmtdx.to,cnmmhdr.to);
               fwrite(&cnmtdx,sizeof(cnmtdx),1,xfd);
               fseek(tfd,(long)(cnmmhdr.control+cnmmhdr.length+cnmmhdr.trailer+sizeof(long)),SEEK_CUR);
            }
            fclose(tfd);
            fclose(xfd);
         } else
            fclose(xfd);
      }
      done=_dos_findnext(&fb);
   }
   putchar('\n');
   _setcursortype(_NORMALCURSOR);
}


void getcfg()
{
   static char *errmsg=" subdirectory not found\n";
   FILE *fd;
   DIR *d;

   fd=fopen("CNMsg.Cfg","rb");
   if(!fd) {
      printf("\nUnable to open CNMsg.Cfg");
      exit(1);
   }
   fread(&cfg,sizeof(cfg),1,fd);
   fclose(fd);
   d=opendir(".\\MAIL");
   if(!d) {
      printf("\nMAIL%s",errmsg);
      exit(1);
   }
   closedir(d);
   d=opendir(".\\SEND");
   if(!d) {
      printf("\nSEND%s",errmsg);
      exit(1);
   }
   closedir(d);
   d=opendir(".\\RCV");
   if(!d) {
      printf("\nRCV%s",errmsg);
      exit(1);
   }
   closedir(d);
   d=opendir(".\\WORK");
   if(!d) {
      printf("\nWORK%s",errmsg);
      exit(1);
   }
   closedir(d);
}


